// AURADlg.cpp : implementation file
//

#include "stdafx.h"
#include "AURA.h"
#include "AURADlg.h"

#pragma comment(lib, "ar.lib")
#include "ar.h"

AR_CLIP clip[11];
HANDLE	drawthreadevent;
HANDLE	drawthread;
DWORD	drawthreadid;
BOOL	drawthreadterminate=FALSE;

CAURADlg *pDlg;
DWORD drawthreadproc(void *pParam);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAURADlg dialog

CAURADlg::CAURADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAURADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAURADlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAURADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAURADlg)
	DDX_Control(pDX, IDC_EFFECTVOL, m_effectvol);
	DDX_Control(pDX, IDC_BACKVOL, m_backvol);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAURADlg, CDialog)
	//{{AFX_MSG_MAP(CAURADlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BACK1, OnBack1)
	ON_BN_CLICKED(IDC_BACK2, OnBack2)
	ON_BN_CLICKED(IDC_BACK3, OnBack3)
	ON_BN_CLICKED(IDC_STOP1, OnStop1)
	ON_BN_CLICKED(IDC_STOP2, OnStop2)
	ON_BN_CLICKED(IDC_STOP3, OnStop3)
	ON_BN_CLICKED(IDC_EFFECT1, OnEffect1)
	ON_BN_CLICKED(IDC_EFFECT2, OnEffect2)
	ON_BN_CLICKED(IDC_EFFECT3, OnEffect3)
	ON_BN_CLICKED(IDC_EFFECT4, OnEffect4)
	ON_BN_CLICKED(IDC_EFFECT5, OnEffect5)
	ON_BN_CLICKED(IDC_EFFECT6, OnEffect6)
	ON_BN_CLICKED(IDC_EFFECT7, OnEffect7)
	ON_BN_CLICKED(IDC_EFFECT8, OnEffect8)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAURADlg message handlers

BOOL CAURADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	AR_InitWaveMixer();
	
	AR_LoadClip("clips/back1.wav", &clip[0]);
	AR_LoadClip("clips/back2.wav", &clip[1]);
	AR_LoadClip("clips/back3.wav", &clip[2]);

	AR_LoadClip("clips/c1.wav", &clip[3]);
	AR_LoadClip("clips/c2.wav", &clip[4]);
	AR_LoadClip("clips/c3.wav", &clip[5]);
	AR_LoadClip("clips/c4.wav", &clip[6]);
	AR_LoadClip("clips/c5.wav", &clip[7]);
	AR_LoadClip("clips/c6.wav", &clip[8]);
	AR_LoadClip("clips/c7.wav", &clip[9]);
	AR_LoadClip("clips/c8.wav", &clip[10]);


	m_backvol.SetRange(0, 256);
	m_backvol.SetPos(128);
	m_effectvol.SetRange(0, 256);
	m_effectvol.SetPos(128);

	pDlg = this;

	drawthreadevent = ::CreateEvent(NULL, FALSE, FALSE, "DrawEvent");
	drawthread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)drawthreadproc, 
						NULL, 0, &drawthreadid);

	AR_SetBlockSendTermEvent(&drawthreadevent);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAURADlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAURADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAURADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAURADlg::OnBack1() 
{
	AR_Play(&clip[0], 0, -1);
}

void CAURADlg::OnBack2() 
{
	AR_Play(&clip[1], 1, -1);
}

void CAURADlg::OnBack3() 
{
	AR_Play(&clip[2], 2, -1);
}

void CAURADlg::OnOK() 
{
	drawthreadterminate = TRUE;
	Sleep(50);

	AR_DestroyWaveMixer();
	CloseHandle(drawthreadevent);
	CloseHandle(drawthread);
	
	CDialog::OnOK();
}

void CAURADlg::OnStop1() 
{
	AR_StopChannel(0);	
}

void CAURADlg::OnStop2() 
{
	AR_StopChannel(1);	
}

void CAURADlg::OnStop3() 
{
	AR_StopChannel(2);	
}

void CAURADlg::OnEffect1() 
{
	AR_Play(&clip[3], 3, 1);
}

void CAURADlg::OnEffect2() 
{
	AR_Play(&clip[4], 3, 1);
}

void CAURADlg::OnEffect3() 
{
	AR_Play(&clip[5], 3, 1);
}

void CAURADlg::OnEffect4() 
{
	AR_Play(&clip[6], 3, 1);
}

void CAURADlg::OnEffect5() 
{
	AR_Play(&clip[7], 3, 1);
}

void CAURADlg::OnEffect6() 
{
	AR_Play(&clip[8], 3, 1);
}

void CAURADlg::OnEffect7() 
{
	AR_Play(&clip[9], 3, 1);
}

void CAURADlg::OnEffect8() 
{
	AR_Play(&clip[10], 3, 1);
}

void CAURADlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar->GetDlgCtrlID() == IDC_BACKVOL)
	{
		AR_SetChannelVolume(0, 0, m_backvol.GetPos());
		AR_SetChannelVolume(1, 0, m_backvol.GetPos());
		AR_SetChannelVolume(2, 0, m_backvol.GetPos());
	}
	
	if (pScrollBar->GetDlgCtrlID() == IDC_EFFECTVOL)
	{
		AR_SetChannelVolume(3, 0, m_effectvol.GetPos());
		AR_SetChannelVolume(4, 0, m_effectvol.GetPos());
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CAURADlg::DrawWave()
{
	CClientDC dc(this);
	int i, xpos, ypos, l;
	AR_STEREO_ELEMENT *se;
	CPen pen, pen2, *oldpen;


	xpos = 330;
	ypos = 280;

	se = AR_GetBlockPointer();

	pen.CreatePen(PS_SOLID, 2, RGB(0, 120, 0));
	pen2.CreatePen(PS_SOLID, 0, RGB(120, 0, 0));

	oldpen = (CPen*)dc.SelectObject(&pen);


	for (l=0; l<4; l++)
	{
		dc.SelectObject(&pen);

		dc.Rectangle(xpos, ypos, xpos+100, ypos+110);
		dc.MoveTo(xpos, ypos+55);
		dc.LineTo(xpos+98, ypos+55);

		dc.SelectObject(&pen2);

		dc.MoveTo(xpos, ypos+30);
		for (i=0; i<100; i++)
			dc.LineTo(xpos+i, ypos+30 + (se[l*2000+i*20].L >> 11));

		dc.MoveTo(xpos, ypos+30);
		for (i=0; i<100; i++)
			dc.LineTo(xpos+i, ypos+80 + (se[l*2000+i*20].R >> 11));

		Sleep(40);
	}

	dc.SelectObject(oldpen);
}

DWORD drawthreadproc(void *pParam)
{
	UINT result;

	while (!drawthreadterminate)
	{
		result = WaitForSingleObject(drawthreadevent, INFINITE);

		if ((result == WAIT_OBJECT_0) && (!drawthreadterminate))
			pDlg->DrawWave();
	}

	ExitThread(0);
    return 0;
}



void CAURADlg::OnPause() 
{
	AR_PauseMaster(!AR_IsMasterPaused());	
}
