
//                    )))Audio Rapper(((
//                          
//                          AURA 1.1
//
//          Multi-Channel Wave-Mixing Audio Library
//                            for
//                           Win32
//
//                        Jinhong kim
//                         1999/10/22
//
//             The AURA supports 32 virtual channels.
//   Also provides functionality of 16 poly-channels per channel.
//
//                       Omni On / Poly



#include <mmsystem.h>

// all available sound formats are automatically converted to
// stereo-16bit-44.1KHz.

// 44100 * 2(quantization) * 2(channel) * 0.2(sec)
#define AR_MAXBUFSIZE	35280  // 8820*4
#define AR_MAXELEMENT	8820
#define AR_MAXCHANNEL	32
#define AR_MAXPOLY		16
#define AR_MAXVOLDEGREE	128

typedef struct _AR_stereo_element
{
	short L;
	short R;
} AR_STEREO_ELEMENT;

typedef struct _AR_clip
{
	LPSTR Data;
	HANDLE DataBlock;
	DWORD Size, CSize;
	DWORD ELNum;

	AR_STEREO_ELEMENT *pSEL;
	short *pMEL;
	int ResampleShift;
	TCHAR FileName[100];

	WAVEFORMATEX wf;
} AR_CLIP;

typedef struct _AR_channelitem
{
	AR_CLIP *clip;
	BOOL used;
	DWORD ELIndex;
	int Loop;
} AR_CHANNELITEM;

typedef struct _AR_channeltable
{
	AR_CHANNELITEM VPC[AR_MAXPOLY]; // Virtual Poly-Channel
	int LeftVol, RightVol;
	int VPCIndex;
	BOOL Playing;
	BOOL Pause;
	BOOL Mute;
} AR_CHANNELTABLE;


#define EXPORTDLL extern "C" __declspec(dllexport)

EXPORTDLL void WINAPI AR_InitWaveMixer();
EXPORTDLL void WINAPI AR_DestroyWaveMixer();

EXPORTDLL BOOL WINAPI AR_LoadClip(TCHAR *fname, AR_CLIP *clip);
EXPORTDLL void WINAPI AR_FreeClip(AR_CLIP *clip);

EXPORTDLL int WINAPI AR_Play(AR_CLIP *clip, int chn, int loop);
EXPORTDLL BOOL WINAPI AR_IsPlaying(int chn);

EXPORTDLL void WINAPI AR_StopChannel(int chn);
EXPORTDLL void WINAPI AR_StopMaster();

EXPORTDLL void WINAPI AR_PauseChannel(int chn, BOOL pause);
EXPORTDLL BOOL WINAPI AR_IsChannelPaused(int chn);
EXPORTDLL BOOL WINAPI AR_IsMasterPaused();
EXPORTDLL void WINAPI AR_PauseMaster(BOOL pause);

EXPORTDLL void WINAPI AR_MuteChannel(int chn, BOOL mute);
EXPORTDLL BOOL WINAPI AR_IsChannelMuted(int chn);

EXPORTDLL void WINAPI AR_SetChannelVolume(int chn, int lrm, int vol);
EXPORTDLL int WINAPI AR_GetChannelVolume(int chn, int lr);

EXPORTDLL DWORD WINAPI AR_GetPosition(int chn, int vpc);
// Future work: AR_SetPosition()

EXPORTDLL void WINAPI AR_SetBlockSendTermEvent(HANDLE *bst_event);
EXPORTDLL AR_STEREO_ELEMENT* WINAPI AR_GetBlockPointer();

